/*
 Tecnisa - Tecnologia em Informtica

 Nome:  0005_FINTMP_ATUALIZA_CHEQUERECE.SQL

 Descrio:
 Atualiza da tabela de cheque com os dados da tabela de tipo de recebimento do boleto

 Criao:
 18/09/2003 - Daniel Costa Salles

@C:\WIN_PRJ\SQL\SqlServer\0005_FINTMP_ATUALIZA_CHEQUERECE.SQL
 */

IF NOT EXISTS (SELECT
                  *
               FROM SYSOBJECTS O, SYSUSERS U
               WHERE
                  O.NAME = 'CHEQUERECE' AND
                  TYPE   = 'U'               AND
                  U.UID  = O.UID             AND
                  U.NAME = USER)
CREATE TABLE CHEQUERECE
(
    NRCHEQUERECE     VARCHAR(6)            NOT NULL,
    CDBANCHEQREC     VARCHAR(3)            NOT NULL,
    CDAGECHEQREC     VARCHAR(5)            NOT NULL,
    CDCNTCHEQREC     VARCHAR(16)           NOT NULL,
    VRCHEQUERECE     FLOAT                 NOT NULL,
    NRCOMCHEQREC     VARCHAR(3)            NULL    ,
    DTRECECHEQUE     DATETIME              NULL    ,
    DTVENCHEQREC     DATETIME              NULL    ,
    CDREDUCONT       VARCHAR(3)            NULL    ,
    CDCLIENTE        VARCHAR(21)           NOT NULL,
    IDTIPCHEQREC     VARCHAR(1)            NOT NULL
        DEFAULT 'P'
        CONSTRAINT CKC_42895819 CHECK (IDTIPCHEQREC IN ('P','T')),
    IDTPICEDCHEQ     VARCHAR(1)            NULL
        CONSTRAINT CKC_42895820 CHECK (IDTPICEDCHEQ IN ('F','J')),
    NRCEDCHEQREC     VARCHAR(20)           NULL    ,
    NMCEDCHEQREC     VARCHAR(40)           NULL    ,
    NRTELCEDCHEQ     VARCHAR(25)           NULL    ,
    IDSITCHEQREC     VARCHAR(1)            NOT NULL
        DEFAULT 'A'
        CONSTRAINT CKC_42895824 CHECK (IDSITCHEQREC IN ('A','C','D','P')),
    DTCOMCHEQREC     DATETIME              NULL    ,
    CONSTRAINT PK_CHEQUERECE PRIMARY KEY (NRCHEQUERECE, CDBANCHEQREC, CDAGECHEQREC, CDCNTCHEQREC)
)
GO
DECLARE @V_NRCHEQUE    VARCHAR(6);
DECLARE @C_CHEQUE_CLIENTE       VARCHAR(21);
DECLARE @C_CHEQUE_REDCONT       VARCHAR(3);
DECLARE @C_CHEQUE_DTVENCB       DATETIME;
DECLARE @C_CHEQUE_NRCHEQBOLREC  VARCHAR(6);
DECLARE @C_CHEQUE_CDBANCBOLREC  VARCHAR(3);
DECLARE @C_CHEQUE_CDAGENBOLREC  VARCHAR(5);
DECLARE @C_CHEQUE_CDCONTBOLREC  VARCHAR(16);
DECLARE @C_CHEQUE_VRCHQREC      FLOAT(15);
DECLARE @C_CHEQUEBAIX_NRCHEQBAIREC VARCHAR(6);
DECLARE @C_CHEQUEBAIX_CDBANCBAIREC VARCHAR(3);
DECLARE @C_CHEQUEBAIX_CDAGENBAIREC VARCHAR(5);
DECLARE @C_CHEQUEBAIX_CDCONTBAIREC VARCHAR(16);
DECLARE @C_CHEQUEBAIX_VRCHQREC     FLOAT(15);

BEGIN
   DECLARE C_CHEQUE CURSOR FOR
                   (SELECT MAX(BO.CDCLIENTE)   CLIENTE,
                           MAX(BO.CDREDUCONT)  REDCONT,
                           MAX(BO.DTVENBOLREC) DTVENCB,
                           TB.NRCHEQBOLREC,
                           TB.CDBANCBOLREC,
                           TB.CDAGENBOLREC,
                           TB.CDCONTBOLREC,
                           SUM(TB.VRTPRECBOLR) VRCHQREC
                    FROM
                       BOLETRECEBER BO,
                       TPRECBOLETO  TB
                    WHERE
                       (BO.CDFILIAL    = TB.CDFILIAL) AND
                       (BO.NRLANBOLREC = TB.NRLANBOLREC)
                    GROUP BY
                       TB.NRCHEQBOLREC,
                       TB.CDBANCBOLREC,
                       TB.CDAGENBOLREC,
                       TB.CDCONTBOLREC)
      OPEN C_CHEQUE;
      FETCH NEXT
      FROM
        C_CHEQUE
      INTO
         @C_CHEQUE_CLIENTE,
         @C_CHEQUE_REDCONT,
         @C_CHEQUE_DTVENCB,
         @C_CHEQUE_NRCHEQBOLREC,
         @C_CHEQUE_CDBANCBOLREC,
         @C_CHEQUE_CDAGENBOLREC,
         @C_CHEQUE_CDCONTBOLREC,
         @C_CHEQUE_VRCHQREC;


      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF (NOT @C_CHEQUE_NRCHEQBOLREC IS NULL) OR
            (NOT @C_CHEQUE_CDBANCBOLREC IS NULL) OR
            (NOT @C_CHEQUE_CDAGENBOLREC IS NULL) OR
            (NOT @C_CHEQUE_CDCONTBOLREC IS NULL) BEGIN

            IF (NOT @C_CHEQUE_NRCHEQBOLREC IS NULL)BEGIN
               UPDATE TPRECBOLETO
               SET
                  CDBANCBOLREC = ISNULL(@C_CHEQUE_CDBANCBOLREC, '000'),
                  CDAGENBOLREC = ISNULL(@C_CHEQUE_CDAGENBOLREC, '00000'),
                  CDCONTBOLREC = ISNULL(@C_CHEQUE_CDCONTBOLREC, '00000-0')
               WHERE
                  NRCHEQBOLREC = @C_CHEQUE_NRCHEQBOLREC;
            END;
            IF (NOT @C_CHEQUE_CDBANCBOLREC IS NULL)BEGIN
               UPDATE TPRECBOLETO
               SET
                  NRCHEQBOLREC = ISNULL(@C_CHEQUE_NRCHEQBOLREC, '000000'),
                  CDAGENBOLREC = ISNULL(@C_CHEQUE_CDAGENBOLREC, '00000'),
                  CDCONTBOLREC = ISNULL(@C_CHEQUE_CDCONTBOLREC, '00000-0')
               WHERE
                  CDBANCBOLREC = @C_CHEQUE_CDBANCBOLREC;
            END;
            IF (NOT @C_CHEQUE_CDAGENBOLREC IS NULL)BEGIN
               UPDATE TPRECBOLETO
               SET
                  NRCHEQBOLREC = ISNULL(@C_CHEQUE_NRCHEQBOLREC, '000000'),
                  CDBANCBOLREC = ISNULL(@C_CHEQUE_CDBANCBOLREC, '000'),
                  CDCONTBOLREC = ISNULL(@C_CHEQUE_CDCONTBOLREC, '00000-0')
               WHERE
                  CDAGENBOLREC = @C_CHEQUE_CDAGENBOLREC;
            END;
            IF (NOT @C_CHEQUE_CDCONTBOLREC IS NULL) BEGIN
               UPDATE TPRECBOLETO
               SET
                  NRCHEQBOLREC = ISNULL(@C_CHEQUE_NRCHEQBOLREC, '000000'),
                  CDBANCBOLREC = ISNULL(@C_CHEQUE_CDBANCBOLREC, '000'),
                  CDAGENBOLREC = ISNULL(@C_CHEQUE_CDAGENBOLREC, '00000')
               WHERE
                  CDCONTBOLREC = @C_CHEQUE_CDCONTBOLREC;
            END;

            SELECT @V_NRCHEQUE = MAX(NRCHEQUERECE)
            FROM CHEQUERECE
            WHERE
               NRCHEQUERECE =  ISNULL(@C_CHEQUE_NRCHEQBOLREC, '000000') AND
               CDBANCHEQREC =  ISNULL(@C_CHEQUE_CDBANCBOLREC, '000')    AND
               CDAGECHEQREC =  ISNULL(@C_CHEQUE_CDAGENBOLREC, '00000')  AND
               CDCNTCHEQREC =  ISNULL(@C_CHEQUE_CDCONTBOLREC, '00000-0');

            IF @V_NRCHEQUE IS NULL BEGIN
               INSERT INTO CHEQUERECE
                  (NRCHEQUERECE,
                   CDBANCHEQREC,
                   CDAGECHEQREC,
                   CDCNTCHEQREC,
                   VRCHEQUERECE,
                   CDCLIENTE,
                   CDREDUCONT,
                   DTVENCHEQREC,
                   IDTIPCHEQREC, IDSITCHEQREC)
               VALUES
                  (ISNULL(@C_CHEQUE_NRCHEQBOLREC, '000000'),
                   ISNULL(@C_CHEQUE_CDBANCBOLREC, '000'),
                   ISNULL(@C_CHEQUE_CDAGENBOLREC, '00000'),
                   ISNULL(@C_CHEQUE_CDCONTBOLREC, '00000-0'),
                   @C_CHEQUE_VRCHQREC,
                   @C_CHEQUE_CLIENTE,
                   @C_CHEQUE_REDCONT,
                   @C_CHEQUE_DTVENCB,
                   'P', 'A');
            END;
         END;
         FETCH NEXT
         FROM
            C_CHEQUE
         INTO
            @C_CHEQUE_CLIENTE,
            @C_CHEQUE_REDCONT,
            @C_CHEQUE_DTVENCB,
            @C_CHEQUE_NRCHEQBOLREC,
            @C_CHEQUE_CDBANCBOLREC,
            @C_CHEQUE_CDAGENBOLREC,
            @C_CHEQUE_CDCONTBOLREC,
            @C_CHEQUE_VRCHQREC;
   END;
   CLOSE C_CHEQUE;
   DEALLOCATE C_CHEQUE;
   DECLARE C_CHEQUEBAIX CURSOR FOR
                       (SELECT NRCHEQBAIREC,
                               CDBANCBAIREC,
                               CDAGENBAIREC,
                               CDCONTBAIREC,
                               SUM(VRTPRECBAIXA) VRCHQREC
                        FROM
                           TPRECBAIXA
                        GROUP BY
                           NRCHEQBAIREC,
                           CDBANCBAIREC,
                           CDAGENBAIREC,
                           CDCONTBAIREC )
      OPEN C_CHEQUEBAIX;
      FETCH NEXT
      FROM
        C_CHEQUEBAIX
      INTO
         @C_CHEQUEBAIX_NRCHEQBAIREC,
         @C_CHEQUEBAIX_CDBANCBAIREC,
         @C_CHEQUEBAIX_CDAGENBAIREC,
         @C_CHEQUEBAIX_CDCONTBAIREC,
         @C_CHEQUEBAIX_VRCHQREC;

      WHILE (@@FETCH_STATUS = 0) BEGIN

      IF (NOT @C_CHEQUEBAIX_NRCHEQBAIREC IS NULL) OR
         (NOT @C_CHEQUEBAIX_CDBANCBAIREC IS NULL) OR
         (NOT @C_CHEQUEBAIX_CDAGENBAIREC IS NULL) OR
         (NOT @C_CHEQUEBAIX_CDCONTBAIREC IS NULL) BEGIN

         IF (NOT @C_CHEQUEBAIX_NRCHEQBAIREC IS NULL) BEGIN
               UPDATE TPRECBAIXA
            SET
               CDBANCBAIREC = ISNULL(@C_CHEQUEBAIX_CDBANCBAIREC, '000'),
               CDAGENBAIREC = ISNULL(@C_CHEQUEBAIX_CDAGENBAIREC, '00000'),
               CDCONTBAIREC = ISNULL(@C_CHEQUEBAIX_CDCONTBAIREC, '00000-0')
            WHERE
               NRCHEQBAIREC = @C_CHEQUEBAIX_NRCHEQBAIREC;
         END;
         IF(NOT @C_CHEQUEBAIX_CDBANCBAIREC IS NULL) BEGIN
               UPDATE TPRECBAIXA
            SET
               NRCHEQBAIREC = ISNULL(@C_CHEQUEBAIX_NRCHEQBAIREC, '000000'),
               CDAGENBAIREC = ISNULL(@C_CHEQUEBAIX_CDAGENBAIREC, '00000'),
               CDCONTBAIREC = ISNULL(@C_CHEQUEBAIX_CDCONTBAIREC, '00000-0')
            WHERE
               CDBANCBAIREC = @C_CHEQUEBAIX_CDBANCBAIREC ;
         END;
         IF(NOT @C_CHEQUEBAIX_CDAGENBAIREC IS NULL) BEGIN
               UPDATE TPRECBAIXA
            SET
               NRCHEQBAIREC = ISNULL(@C_CHEQUEBAIX_NRCHEQBAIREC, '000000'),
               CDBANCBAIREC = ISNULL(@C_CHEQUEBAIX_CDBANCBAIREC, '000'),
               CDCONTBAIREC = ISNULL(@C_CHEQUEBAIX_CDCONTBAIREC, '00000-0')
            WHERE
               CDAGENBAIREC = @C_CHEQUEBAIX_CDAGENBAIREC;
         END;
         IF(NOT @C_CHEQUEBAIX_CDCONTBAIREC IS NULL) BEGIN
               UPDATE TPRECBAIXA
            SET
               NRCHEQBAIREC = ISNULL(@C_CHEQUEBAIX_NRCHEQBAIREC, '000000'),
               CDBANCBAIREC = ISNULL(@C_CHEQUEBAIX_CDBANCBAIREC, '000'),
               CDAGENBAIREC = ISNULL(@C_CHEQUEBAIX_CDAGENBAIREC, '00000')
            WHERE
               CDCONTBAIREC = @C_CHEQUEBAIX_CDCONTBAIREC;

         END;
      END;
      FETCH NEXT
      FROM
         C_CHEQUEBAIX
      INTO
         @C_CHEQUEBAIX_NRCHEQBAIREC,
         @C_CHEQUEBAIX_CDBANCBAIREC,
         @C_CHEQUEBAIX_CDAGENBAIREC,
         @C_CHEQUEBAIX_CDCONTBAIREC,
         @C_CHEQUEBAIX_VRCHQREC;
   END;
   CLOSE C_CHEQUEBAIX;
   DEALLOCATE C_CHEQUEBAIX;
END;
GO

DECLARE
   @V_HISTCHEQUE VARCHAR(6);
BEGIN
   SELECT @V_HISTCHEQUE = MAX(CDOPERACAO)
   FROM HISTINTEGRA
   WHERE
      CDOPERACAO =  'BXPADI';
   IF @V_HISTCHEQUE IS NULL BEGIN
      INSERT INTO HISTINTEGRA
         (CDOPERACAO)
      VALUES
         ('BXPADI');
   END;
END;
GO
